/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava.core.shareddata;

import java.util.Map;
import rx.Observable;
import rx.Single;

/**
 * An asynchronous exclusive lock which can be obtained from any node in the cluster.
 * <p>
 * When the lock is obtained, no-one else in the cluster can obtain the lock with the same name until the lock
 * is released.
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.core.shareddata.Lock original} non RX-ified interface using Vert.x codegen.
 */

@io.vertx.lang.rxjava.RxGen(io.vertx.core.shareddata.Lock.class)
public class Lock {

  public static final io.vertx.lang.rxjava.TypeArg<Lock> __TYPE_ARG = new io.vertx.lang.rxjava.TypeArg<>(
    obj -> new Lock((io.vertx.core.shareddata.Lock) obj),
    Lock::getDelegate
  );

  private final io.vertx.core.shareddata.Lock delegate;
  
  public Lock(io.vertx.core.shareddata.Lock delegate) {
    this.delegate = delegate;
  }

  public io.vertx.core.shareddata.Lock getDelegate() {
    return delegate;
  }

  /**
   * Release the lock. Once the lock is released another will be able to obtain the lock.
   */
  public void release() { 
    delegate.release();
  }


  public static  Lock newInstance(io.vertx.core.shareddata.Lock arg) {
    return arg != null ? new Lock(arg) : null;
  }
}
